function hf = drawFext(rbt, ax, q, fext)
%% DRAWFEXT
%
% Inputs:
%
%   RBT                     Description of argument RBT
% 
%   AX                      Description of argument AX
% 
%   Q                       Description of argument Q
% 
%   FEXT                    Description of argument FEXT
%
% Authors:
%   Philipp Tempel <philipp.tempel@ls2n.fr>



%% Parse arguments

% DRAWFEXT(ROBOT, AX, Q, FEXT)
narginchk(4, 4);

% DRAWFEXT(___)
% HF = DRAWFEXT(___)
nargoutchk(0, 1);



%% Algorithm

% Get position of each joint
T = reconstructKinematics(rbt, q);

% HG group for all external forces
hf = hggroup( ...
    ax ...
  , 'Tag', 'F^{ext}' ...
);

% Loop over each body
nb = rbt.NumBody;
for ib = 1:nb
  % Plot force part of force
  hf_ = hgtransform( ...
      ax ...
    , 'Tag'   , sprintf('F^ext_{%.0f}', ib) ...
    , 'Matrix', T(:,:,ib) ...
  );
  
  % Get force
  fext_ = fext(4:6,ib);
  % Its norm
  fext_n = norm(fext_);
  % And its normalize direction
  if fext_n > 0
    fext_ = fext_ ./ fext_n;
  end
  
  % Plot forces as 3D vector
  hf_f = plot3( ...
      ax ...
    , [ 0 , fext_(1) ], [ 0 , fext_(2) ], [ 0 , fext_(3) ] ...
    , 'Color'           , color('fuchsia') ...
    , 'LineStyle'       , '-' ...
    , 'LineWidth'       , exp(fext_n ^ (1 /4)) / 2 ...
    , 'Tag'             , sprintf('N^{ext}_{%.0f}', ib) ...
    , 'Clipping'        , 'off' ...
    , 'XLimInclude'     , 'off' ...
    , 'YLimInclude'     , 'off' ...
    , 'ZLimInclude'     , 'off' ...
  );
%   hf_f = quiver3( ...
%       ax ...
%     , 0, 0, 0 ...
%     , fext_(1), fext_(2), fext_(3) ...
%     , 'Color'           , color('fuchsia') ...
%     , 'LineStyle'       , '-' ...
%     , 'LineWidth'       , exp(fext_n ^ (1 /4)) / 2 ...
%     , 'MaxHeadSize'     , 0.50 ...
%     , 'AutoScale'       , 'off' ...
%     , 'AutoScaleFactor' , 1.0 ...
%     , 'Tag'             , sprintf('N^{ext}_{%.0f}', ib) ...
%     , 'Clipping'        , 'off' ...
%     , 'XLimInclude'     , 'off' ...
%     , 'YLimInclude'     , 'off' ...
%     , 'ZLimInclude'     , 'off' ...
%   );
  
  % Assign parents of plot objects and of transforms
  set(hf_f, 'Parent', hf_);
  set(hf_, 'Parent', hf);
  
end


end

%------------- END OF CODE --------------
% Please send suggestions for improvement of this file to the original author as
% can be found in the header. Your contribution towards improving this function
% will be acknowledged in the "Changelog" section of the header.
